#include "estbench.h"

#include <suifkernel/iter.h>
#include <basicnodes/basic.h>
#include <esuifnodes/esuif.h>

EstBench::EstBench(SuifEnv *env)
{
}

EstBench::~EstBench()
{
}

void EstBench::fileSetBlock(const FileSetBlock *fsb)
{
  suif_assert(fsb != 0);

  // Call module on each module found

  for (Iter<FileBlock*> fbi = fsb->get_file_block_iterator() ;
       fbi.is_valid() ; fbi.next() ) {

    DefinitionBlock *db = fbi.current()->get_definition_block();
    suif_assert( db );

    for ( Iter<ProcedureDefinition*> pditer =
	    db->get_procedure_definition_iterator() ;
	  pditer.is_valid() ; pditer.next() ) {
      if (is_a<ModuleDefinition>(pditer.current())) {
	module(to<ModuleDefinition>(pditer.current()));
	result += "\n\n";
      }
    }
  }

}

void EstBench::module(const ModuleDefinition *md)
{
  result += "module ";
  result += md->get_procedure_symbol()->get_name();
  result += "\n";
}
